#!/bin/bash

base_folder=~
cd ${base_folder}

### Configuração inicial ###
apt-get update -y && apt-get upgrade -y
# deluser --remove-all-files pi

### Alterar senha do root ###
root_pw=utfprlt38c 
echo "root:${root_pw}" | chpasswd

### Permitir login do root por SSH ###
root_login_opt=PermitRootLogin
root_login_value=yes
sed -i "s/^[\s|#]*${root_login_opt}\s.*$/${root_login_opt} ${root_login_value}/g" /etc/ssh/sshd_config
systemctl restart sshd


### Mudar nome do host ###
change_host_name=pedro
sed -i "s/raspberrypi/${change_host_name}/" /etc/hosts


### Instalar biblioteca bcm2835 ###
# bcm_ver=1.69
# bcm_name=bcm2835
# bcm_base=${bcm_name}-${bcm_ver}
# bcm_full_name=${bcm_base}.tar.gz
# wget www.airspayce.com/mikem/${bcm_name}/${bcm_full_name} -O ${bcm_full_name}
# tar zxvf ${bcm_full_name}
# cd ${bcm_base}
# ./configure
# make
# make check
# make install
# cd ${base_folder}


### Instalar MariaDB ###
apt-get install mariadb-server -y
apt-get install libmariadb3 libmariadb-dev -y
# apt-get install mariadb-client -y

### Configurar MariaDB ###
mysql_password=mysqllt38c
mysqladmin -u root password "${mysql_password}"
mysql_secure_installation
scp /etc/mysql/my.cnf /etc/mysql/my.cnf.bkp
echo "[mysqld]" >> /etc/mysql/my.cnf
echo "bind-address = 0.0.0.0" >> /etc/mysql/my.cnf
service mysql restart
mysql -u root -p${mysql_password} -Bse "GRANT ALL ON *.* TO 'root'@'%' IDENTIFIED BY '${mysql_password}' WITH GRANT OPTION;"
mysql -u root -p${mysql_password} -Bse "FLUSH PRIVILEGES;"
mysql -u root -p${mysql_password} -Bse "create database lt38c;"
echo 'SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;
-- ----------------------------
-- Table structure for arduino
-- ----------------------------
CREATE OR REPLACE TABLE `arduino`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `versao` tinytext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL,
  `firmware` blob NOT NULL,
  `datah` timestamp DEFAULT CURRENT_TIMESTAMP,
  `sync` tinyint(4) DEFAULT 0,
  `sync_time` timestamp NULL DEFAULT NULL,
  `email` tinytext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL,
  `md5sum` tinytext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Compact;
SET FOREIGN_KEY_CHECKS = 1;' > /tmp/arduino.sql
cat /tmp/arduino.sql | mariadb -u root -p${mysql_password} lt38c


### avrdude (upload de firmware)
apt-get install avrdude -y


### Flask (webserver) ###
apt-get install python3 -y && apt-get install python3-venv -y
python3 -m venv flask-server
cd flask-server
source ./bin/activate
pip install Flask
pip install mariadb
deactivate
cd ${base_folder}


apt-get install tmux -y