#include <mysql.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

static const char * host = "localhost";
static const char * user = "root";
static const char * password = "mysqllt38c";
static const char * database = "lt38c";

static const char * SELECT_QUERY = "SELECT id, sync, firmware, md5sum from " "arduino" " ORDER BY datah DESC LIMIT 1;";
static const char * UPDATE_QUERY = "UPDATE " "arduino" " SET sync='1', sync_time=CURRENT_TIMESTAMP WHERE id='%s'";
static const char * AVRDUDE_UPLOAD = "avrdude -c arduino -p m328p -P /dev/ttyACM0 -b 115200 -D -U " "/tmp/" "hexfile.hex" " -q -q" ;

void wait(unsigned int secs)
{
    unsigned int startTime = time(0);
    while (time(0) - startTime < secs)
        ;
}

int main()
{
    MYSQL * conn = mysql_init(NULL); //https://mariadb.com/kb/en/mysql_init/
    if (!conn)
    {
        fprintf(stderr, "%s\n", mysql_error(conn));
        exit(1);
    }
    printf("Initialized!\n");
    if (!(mysql_real_connect(conn, host, user, password, database, 0, NULL, 0)))
    {
        exit(2);
    }
    printf("Connected!\n");
    do
    {
        wait(2);
        if (mysql_query(conn, SELECT_QUERY) != 0)
        {
            continue;
        }

        MYSQL_RES * result = mysql_store_result(conn);
        if (result == NULL)
        {
            continue;
        }

        MYSQL_ROW rows = mysql_fetch_row(result);
        if (rows == NULL) {
            continue;
        }

        if (*rows[1] == '0'){ // Ainda nao foi sincronizado
            FILE *fp;

            // Salva o .hex recebido do banco de dados
            fp = fopen("/tmp/hexfile.hex", "w");
            fprintf(fp, rows[2]);
            fclose(fp);

            // salva o md5 recebido do banco de dados, no formato esperado pelo
            // programa md5sum:
            // hash em hexadecimal espaço, espaço, arquivo corerspondente
            fp = fopen("/tmp/hexfile.md5", "w");
            fprintf(fp, "%s  /tmp/hexfile.hex", rows[3]);
            fclose(fp);
            int md5ret = system("md5sum --check /tmp/hexfile.md5 --status");
            int md5status = WEXITSTATUS(md5ret);
            if (md5status == 0){
                int avrduderet = system(AVRDUDE_UPLOAD);
                int avrdudestatus = WEXITSTATUS(avrduderet);
                if (avrdudestatus != 0) {
                    // erro no upload: arquivo corrupto, dispositivo nao conectado etc
                    printf("Erro no upload\n");
                    continue;
                }
            }
            else {
                // hash do BD nao coincide com hash do firmware baixado
                printf("Md5 nao coincide\n");
                continue;
            }

            // Sucesso: atualiza `sync`
            char updateQuerySubs[128];
            sprintf(updateQuerySubs, UPDATE_QUERY, rows[0]);
            mysql_query(conn, updateQuerySubs);
            printf("id=%s sincronizado!\n", rows[0]);
        }
        mysql_free_result(result);
    } while (1);
    return 0;
}